/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.za = null;
        _this.zb = null;
        _this.zr = 0;
        _this.zt = 5;
        _this.zs = 0;
        _this.zq = 5;
        _this.z8 = 5;
        _this.aaa = 0;
        _this.z9 = 5;
        _this.z7 = 0;
        _this.ae1 = null;
        _this.ae8 = null;
        _this.aez = null;
        _this.ae0 = null;
        _this.z2 = 0;
        _this.aaj = 0;
        _this.z1 = NaN;
        _this.aai = NaN;
        _this.z4 = NaN;
        _this.aal = NaN;
        _this.z3 = NaN;
        _this.aak = NaN;
        _this.z0 = NaN;
        _this.aah = NaN;
        _this.ae7 = null;
        _this.afe = null;
        _this.abt = null;
        _this.abx = null;
        _this.abv = null;
        _this.abz = null;
        _this.abo = null;
        _this.abp = null;
        _this.ae2 = null;
        _this.ae9 = null;
        _this.zu = DeviceUtils.g(1);
        _this.aab = DeviceUtils.g(1);
        _this.zv = DeviceUtils.g(1);
        _this.aac = DeviceUtils.g(1);
        _this.ae4 = null;
        _this.afb = null;
        _this.ae5 = null;
        _this.afc = null;
        _this.zw = DeviceUtils.g(1);
        _this.aad = DeviceUtils.g(1);
        _this.zx = DeviceUtils.g(8);
        _this.aae = 0;
        _this.ae6 = null;
        _this.afd = null;
        _this.zy = DeviceUtils.g(1);
        _this.aaf = DeviceUtils.g(1);
        _this.abu = null;
        _this.aby = null;
        _this.ae3 = null;
        _this.afa = null;
        _this.zp = 0;
        _this.z6 = 0;
        _this.zo = NaN;
        _this.z5 = NaN;
        _this.zz = 0;
        _this.aag = -90;
        _this.zk = false;
        _this.zl = false;
        _this.aeu = 1;
        _this.afx = 1;
        _this.aet = 1;
        _this.aev = 2;
        _this.afv = 0;
        _this.afw = 1;
        _this.af1 = 0;
        _this.af2 = 0;
        _this.zi = 4;
        _this.zg = 4;
        _this.abs = null;
        _this.y4 = null;
        _this.abw = null;
        _this.y5 = null;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.y8();
            var c = this.y9();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.ur = function () {
        _super.prototype.ur.call(this);
        var a = this.y8();
        var b = this.y9();
        if (a != null && a.az != null) {
            this.afh = a.az.textColor;
        }
        if (b != null && b.az != null) {
            this.afo = b.az.textColor;
        }
        this.afm = AxisDefaults.j;
        this.aft = AxisDefaults.j;
        this.afi = AxisDefaults.h;
        this.afp = AxisDefaults.h;
        this.afl = AxisDefaults.g;
        this.afs = AxisDefaults.g;
    };
    XYChart.prototype.vi = function (a, b, c) {
        var _this = this;
        _super.prototype.vi.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.ael(function (d) { return d.leftMargin = _this.aat; });
                break;
            case "XAxisLabelTopMargin":
                this.ael(function (d) { return d.topMargin = _this.aav; });
                break;
            case "XAxisLabelRightMargin":
                this.ael(function (d) { return d.rightMargin = _this.aau; });
                break;
            case "XAxisLabelBottomMargin":
                this.ael(function (d) { return d.bottomMargin = _this.aas; });
                break;
            case "YAxisLabelLeftMargin":
                this.aeq(function (d) { return d.leftMargin = _this.aba; });
                break;
            case "YAxisLabelTopMargin":
                this.aeq(function (d) { return d.topMargin = _this.abc; });
                break;
            case "YAxisLabelRightMargin":
                this.aeq(function (d) { return d.rightMargin = _this.abb; });
                break;
            case "YAxisLabelBottomMargin":
                this.aeq(function (d) { return d.bottomMargin = _this.aa9; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.aff = this.x4(this.afh);
                this.afg = this.x4(this.afo);
                break;
            case "XAxisLabelTextColor":
                this.aff = this.x4(this.afh);
                break;
            case "YAxisLabelTextColor":
                this.afg = this.x4(this.afo);
                break;
            case "ActualXAxisLabelTextColor":
                this.ael(function (d) { return d.textColor = _this.aff; });
                break;
            case "ActualYAxisLabelTextColor":
                this.aeq(function (d) { return d.textColor = _this.afg; });
                break;
            case "XAxisTitleMargin":
                this.aen(function (d) { return d.margin = _this.aa4; });
                break;
            case "YAxisTitleMargin":
                this.aes(function (d) { return d.margin = _this.abl; });
                break;
            case "XAxisTitleLeftMargin":
                this.aen(function (d) { return d.leftMargin = _this.aa3; });
                break;
            case "YAxisTitleLeftMargin":
                this.aes(function (d) { return d.leftMargin = _this.abk; });
                break;
            case "XAxisTitleTopMargin":
                this.aen(function (d) { return d.topMargin = _this.aa6; });
                break;
            case "YAxisTitleTopMargin":
                this.aes(function (d) { return d.topMargin = _this.abn; });
                break;
            case "XAxisTitleRightMargin":
                this.aen(function (d) { return d.rightMargin = _this.aa5; });
                break;
            case "YAxisTitleRightMargin":
                this.aes(function (d) { return d.rightMargin = _this.abm; });
                break;
            case "XAxisTitleBottomMargin":
                this.aen(function (d) { return d.bottomMargin = _this.aa2; });
                break;
            case "YAxisTitleBottomMargin":
                this.aes(function (d) { return d.bottomMargin = _this.abj; });
                break;
            case "XAxisTitleTextColor":
                this.aen(function (d) { return d.textColor = _this.afn; });
                break;
            case "YAxisTitleTextColor":
                this.aes(function (d) { return d.textColor = _this.afu; });
                break;
            case "XAxisFormatLabel":
                this.aej(function (d) { return d.au = _this.zc; });
                break;
            case "YAxisFormatLabel":
                this.aeo(function (d) { return d.au = _this.zd; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "zc", {
        get: function () {
            return this.za;
        },
        set: function (a) {
            var b = this.zc;
            if (a != b) {
                this.za = a;
                this.vf("XAxisFormatLabel", b, this.zc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zd", {
        get: function () {
            return this.zb;
        },
        set: function (a) {
            var b = this.zd;
            if (a != b) {
                this.zb = a;
                this.vf("YAxisFormatLabel", b, this.zd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aat", {
        get: function () {
            return this.zr;
        },
        set: function (a) {
            var b = this.aat;
            if (a != b) {
                this.zr = a;
                this.vf("XAxisLabelLeftMargin", b, this.aat);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aav", {
        get: function () {
            return this.zt;
        },
        set: function (a) {
            var b = this.aav;
            if (a != b) {
                this.zt = a;
                this.vf("XAxisLabelTopMargin", b, this.aav);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aau", {
        get: function () {
            return this.zs;
        },
        set: function (a) {
            var b = this.aau;
            if (a != b) {
                this.zs = a;
                this.vf("XAxisLabelRightMargin", b, this.aau);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aas", {
        get: function () {
            return this.zq;
        },
        set: function (a) {
            var b = this.aas;
            if (a != b) {
                this.zq = a;
                this.vf("XAxisLabelBottomMargin", b, this.aas);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aba", {
        get: function () {
            return this.z8;
        },
        set: function (a) {
            var b = this.aba;
            if (a != b) {
                this.z8 = a;
                this.vf("YAxisLabelLeftMargin", b, this.aba);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abc", {
        get: function () {
            return this.aaa;
        },
        set: function (a) {
            var b = this.abc;
            if (a != b) {
                this.aaa = a;
                this.vf("YAxisLabelTopMargin", b, this.abc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abb", {
        get: function () {
            return this.z9;
        },
        set: function (a) {
            var b = this.abb;
            if (a != b) {
                this.z9 = a;
                this.vf("YAxisLabelRightMargin", b, this.abb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa9", {
        get: function () {
            return this.z7;
        },
        set: function (a) {
            var b = this.aa9;
            if (a != b) {
                this.z7 = a;
                this.vf("YAxisLabelBottomMargin", b, this.aa9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afh", {
        get: function () {
            return this.ae1;
        },
        set: function (a) {
            var b = this.afh;
            if (a != b) {
                this.ae1 = a;
                this.vf("XAxisLabelTextColor", b, this.afh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afo", {
        get: function () {
            return this.ae8;
        },
        set: function (a) {
            var b = this.afo;
            if (a != b) {
                this.ae8 = a;
                this.vf("YAxisLabelTextColor", b, this.afo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aff", {
        get: function () {
            return this.aez;
        },
        set: function (a) {
            var b = this.aez;
            if (a != b) {
                this.aez = a;
                this.vf("ActualXAxisLabelTextColor", b, this.aff);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afg", {
        get: function () {
            return this.ae0;
        },
        set: function (a) {
            var b = this.ae0;
            if (a != b) {
                this.ae0 = a;
                this.vf("ActualYAxisLabelTextColor", b, this.afg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa4", {
        get: function () {
            return this.z2;
        },
        set: function (a) {
            var b = this.aa4;
            if (a != b) {
                this.z2 = a;
                this.vf("XAxisTitleMargin", b, this.aa4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abl", {
        get: function () {
            return this.aaj;
        },
        set: function (a) {
            var b = this.abl;
            if (a != b) {
                this.aaj = a;
                this.vf("YAxisTitleMargin", b, this.abl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa3", {
        get: function () {
            return this.z1;
        },
        set: function (a) {
            var b = this.aa3;
            if (a != b) {
                this.z1 = a;
                this.vf("XAxisTitleLeftMargin", b, this.aa3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abk", {
        get: function () {
            return this.aai;
        },
        set: function (a) {
            var b = this.abk;
            if (a != b) {
                this.aai = a;
                this.vf("YAxisTitleLeftMargin", b, this.abk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa6", {
        get: function () {
            return this.z4;
        },
        set: function (a) {
            var b = this.aa6;
            if (a != b) {
                this.z4 = a;
                this.vf("XAxisTitleTopMargin", b, this.aa6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abn", {
        get: function () {
            return this.aal;
        },
        set: function (a) {
            var b = this.abn;
            if (a != b) {
                this.aal = a;
                this.vf("YAxisTitleTopMargin", b, this.abn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa5", {
        get: function () {
            return this.z3;
        },
        set: function (a) {
            var b = this.aa5;
            if (a != b) {
                this.z3 = a;
                this.vf("XAxisTitleRightMargin", b, this.aa5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abm", {
        get: function () {
            return this.aak;
        },
        set: function (a) {
            var b = this.abm;
            if (a != b) {
                this.aak = a;
                this.vf("YAxisTitleRightMargin", b, this.abm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa2", {
        get: function () {
            return this.z0;
        },
        set: function (a) {
            var b = this.aa2;
            if (a != b) {
                this.z0 = a;
                this.vf("XAxisTitleBottomMargin", b, this.aa2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abj", {
        get: function () {
            return this.aah;
        },
        set: function (a) {
            var b = this.abj;
            if (a != b) {
                this.aah = a;
                this.vf("YAxisTitleBottomMargin", b, this.abj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afn", {
        get: function () {
            return this.ae7;
        },
        set: function (a) {
            var b = this.afn;
            if (a != b) {
                this.ae7 = a;
                this.vf("XAxisTitleTextColor", b, this.afn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afu", {
        get: function () {
            return this.afe;
        },
        set: function (a) {
            var b = this.afu;
            if (a != b) {
                this.afe = a;
                this.vf("YAxisTitleTextColor", b, this.afu);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.vj = function (a, b, c) {
        var _this = this;
        _super.prototype.vj.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.ael(function (d) { return d.textStyle = _this.ach; });
                break;
            case "YAxisLabelTextStyle":
                this.aeq(function (d) { return d.textStyle = _this.adm; });
                break;
            case "XAxisTitleTextStyle":
                this.aen(function (d) { return d.textStyle = _this.ac5; });
                break;
            case "YAxisTitleTextStyle":
                this.aes(function (d) { return d.textStyle = _this.aea; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "ach", {
        get: function () {
            return this.abt;
        },
        set: function (a) {
            var b = this.ach;
            if (a != b) {
                this.abt = a;
                this.vf("XAxisLabelTextStyle", b, this.ach);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adm", {
        get: function () {
            return this.abx;
        },
        set: function (a) {
            var b = this.adm;
            if (a != b) {
                this.abx = a;
                this.vf("YAxisLabelTextStyle", b, this.adm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac5", {
        get: function () {
            return this.abv;
        },
        set: function (a) {
            var b = this.ac5;
            if (a != b) {
                this.abv = a;
                this.vf("XAxisTitleTextStyle", b, this.ac5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aea", {
        get: function () {
            return this.abz;
        },
        set: function (a) {
            var b = this.aea;
            if (a != b) {
                this.abz = a;
                this.vf("YAxisTitleTextStyle", b, this.aea);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.aeg = function (a) {
        var _this = this;
        this.aed(a, function (b) { return b.leftMargin = _this.aat; });
        this.aed(a, function (b) { return b.topMargin = _this.aav; });
        this.aed(a, function (b) { return b.rightMargin = _this.aau; });
        this.aed(a, function (b) { return b.bottomMargin = _this.aas; });
        this.aed(a, function (b) { return b.textColor = _this.aff; });
        this.aee(a, function (b) { return b.textColor = _this.afn; });
        this.aee(a, function (b) { return b.leftMargin = _this.aa3; });
        this.aee(a, function (b) { return b.topMargin = _this.aa6; });
        this.aee(a, function (b) { return b.rightMargin = _this.aa5; });
        this.aee(a, function (b) { return b.bottomMargin = _this.aa2; });
        this.aed(a, function (b) { return b.textStyle = _this.ach; });
        this.aee(a, function (b) { return b.textStyle = _this.ac5; });
    };
    XYChart.prototype.aei = function (a) {
        var _this = this;
        this.aed(a, function (b) { return b.leftMargin = _this.aba; });
        this.aed(a, function (b) { return b.topMargin = _this.abc; });
        this.aed(a, function (b) { return b.rightMargin = _this.abb; });
        this.aed(a, function (b) { return b.bottomMargin = _this.aa9; });
        this.aed(a, function (b) { return b.textColor = _this.afg; });
        this.aee(a, function (b) { return b.textColor = _this.afu; });
        this.aee(a, function (b) { return b.leftMargin = _this.abk; });
        this.aee(a, function (b) { return b.topMargin = _this.abn; });
        this.aee(a, function (b) { return b.rightMargin = _this.abm; });
        this.aee(a, function (b) { return b.bottomMargin = _this.abj; });
        this.aed(a, function (b) { return b.textStyle = _this.adm; });
        this.aee(a, function (b) { return b.textStyle = _this.aea; });
    };
    XYChart.prototype.v3 = function (a) {
        var b = this.bi(a);
        var c = this.da(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = this.hw(a);
        if (a.highlightedData != null) {
            c.highlightedItemsSource = this.hx(a);
        }
        c.name = this.qe(a);
        c.title = this.qf(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.aej = function (a) {
        this.aek(a, null);
    };
    XYChart.prototype.aek = function (a, b) {
        a(this.y8());
    };
    XYChart.prototype.aep = function (a, b) {
        a(this.y9());
    };
    XYChart.prototype.aeo = function (a) {
        this.aep(a, true);
    };
    XYChart.prototype.ub = function (a, b) {
        this.aej(a);
        this.aep(a, b);
    };
    XYChart.prototype.aen = function (a) {
        this.aee(this.y8(), a);
    };
    XYChart.prototype.aes = function (a) {
        this.aee(this.y9(), a);
    };
    XYChart.prototype.aeq = function (a) {
        this.aed(this.y9(), a);
    };
    XYChart.prototype.ael = function (a) {
        this.aed(this.y8(), a);
    };
    XYChart.prototype.aam = function (a) {
        var b = this.y8();
        return b.ek(a, new ScalerParams(1, this.yd, this.yc, b.ch));
    };
    XYChart.prototype.aao = function (a) {
        var b = this.y8();
        return b.en(a, new ScalerParams(1, this.yd, this.yc, b.ch));
    };
    XYChart.prototype.aan = function (a) {
        var b = this.y9();
        return b.ek(a, new ScalerParams(1, this.yd, this.yc, b.ch));
    };
    XYChart.prototype.aap = function (a) {
        var b = this.y9();
        return b.en(a, new ScalerParams(1, this.yd, this.yc, b.ch));
    };
    XYChart.prototype.v0 = function (a) {
        _super.prototype.v0.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.y8();
            var c = this.y9();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.ab2 = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    XYChart.prototype.um = function (a, b) {
        _super.prototype.um.call(this, a, b);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.y8());
            this.dataChart.axes.add(this.y9());
        }
    };
    XYChart.prototype.aef = function (a) {
        var _this = this;
        if (a != null && this.lo != null && a.fm == null) {
            a.provideRenderer(this.lo);
        }
        a.jx = this.afi;
        a.es = this.aaw;
        a.jy = this.afj;
        a.ev = this.aax;
        a.j0 = this.afl;
        a.fh = this.aay;
        a.jz = this.afk;
        a.fi = this.aaz;
        a.j1 = this.afm;
        a.fj = this.aa0;
        a.c4 = true;
        a.cu = this.ha;
        a.cw = this.ha;
        var b = a == this.y8();
        if (b) {
            a.g7 = this.acw;
        }
        a.f1 = this.abq;
        a.gh = this.ab8;
        a.ah = this.y6;
        this.aed(a, function (c) { return c.angle = _this.aar; });
        this.aed(a, function (c) {
            if (c.extent != _this.aaq) {
                c.extent = _this.aaq;
            }
        });
        this.aed(a, function (c) { return c.horizontalAlignment = _this.aew; });
        this.aed(a, function (c) { return c.verticalAlignment = _this.afy; });
        this.aed(a, function (c) { return c.visibility = _this.af3; });
        this.aed(a, function (c) { return c.location = _this.ze(_this.zh); });
        this.aee(a, function (c) { return c.horizontalAlignment = _this.aex; });
        this.aee(a, function (c) { return c.angle = _this.aa1; });
        this.aeg(a);
    };
    XYChart.prototype.aeh = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.lo != null && a.fm == null) {
            a.provideRenderer(this.lo);
        }
        a.cu = this.ha;
        a.cw = this.ha;
        this.aed(a, function (b) { return b.angle = _this.aa8; });
        this.aed(a, function (b) {
            if (b.extent != _this.aa7) {
                b.extent = _this.aa7;
            }
        });
        this.aed(a, function (b) { return b.horizontalAlignment = _this.aey; });
        this.aed(a, function (b) { return b.verticalAlignment = _this.afz; });
        this.aed(a, function (b) { return b.visibility = _this.af4; });
        this.aed(a, function (b) { return b.location = _this.zf(_this.zj); });
        this.aee(a, function (b) { return b.verticalAlignment = _this.af0; });
        this.aee(a, function (b) { return b.angle = _this.abi; });
        a.jx = this.afp;
        a.es = this.abd;
        a.jy = this.afq;
        a.ev = this.abe;
        a.j0 = this.afs;
        a.fh = this.abf;
        a.jz = this.afr;
        a.fi = this.abg;
        a.j1 = this.aft;
        a.fj = this.abh;
        var b = a == this.y9();
        if (b) {
            a.g7 = this.ad1;
        }
        a.gh = this.add;
        a.ah = this.y7;
        this.aei(a);
    };
    XYChart.prototype.uj = function () {
        _super.prototype.uj.call(this);
        this.aef(this.y8());
        this.aeh(this.y9());
    };
    XYChart.prototype.aed = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.az == null) {
            a.az = new AxisLabelSettings();
            a.az.angle = a.d6();
            a.az.bottomMargin = a.d7();
            a.az.leftMargin = a.d8();
            a.az.rightMargin = a.d9();
            a.az.topMargin = a.ea();
            a.az.horizontalAlignment = a.js();
            a.az.location = a.a0();
            a.az.verticalAlignment = a.kl();
        }
        b(a.az);
    };
    XYChart.prototype.aee = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bf == null) {
            a.bf = new TitleSettings();
            a.bf.bottomMargin = a.ec();
            a.bf.leftMargin = a.ed();
            a.bf.rightMargin = a.ee();
            a.bf.topMargin = a.ef();
            a.bf.location = a.a1();
            a.bf.angle = a.eb();
            a.bf.horizontalAlignment = a.jt();
            a.bf.verticalAlignment = a.km();
        }
        b(a.bf);
    };
    XYChart.prototype.vf = function (a, b, c) {
        var _this = this;
        _super.prototype.vf.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.ael(function (d) { return d.angle = _this.aar; });
                break;
            case "YAxisLabelAngle":
                this.aeq(function (d) { return d.angle = _this.aa8; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.ael(function (d) { return d.horizontalAlignment = _this.aew; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.aeq(function (d) { return d.horizontalAlignment = _this.aey; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.ael(function (d) { return d.verticalAlignment = _this.afy; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.aeq(function (d) { return d.verticalAlignment = _this.afz; });
                break;
            case "XAxisLabelVisibility":
                this.ael(function (d) { return d.visibility = _this.af3; });
                break;
            case "YAxisLabelVisibility":
                this.aeq(function (d) { return d.visibility = _this.af4; });
                break;
            case "XAxisLabel":
                this.aej(function (d) { return d.f1 = _this.abq; });
                break;
            case "YAxisLabel":
                this.aeo(function (d) { return d.f1 = _this.abr; });
                break;
            case "XAxisLabelFormat":
                this.aej(function (d) { return d.gh = _this.ab8; });
                break;
            case "XAxisLabelFormatSpecifiers":
                this.aej(function (d) { return d.ah = _this.y6; });
                break;
            case "YAxisLabelFormat":
                this.aeo(function (d) { return d.gh = _this.add; });
                break;
            case "YAxisLabelFormatSpecifiers":
                this.aeo(function (d) { return d.ah = _this.y7; });
                break;
            case "XAxisTitleAngle":
                this.aen(function (d) { return d.angle = _this.aa1; });
                break;
            case "YAxisTitleAngle":
                this.aes(function (d) { return d.angle = _this.abi; });
                break;
            case "XAxisTitleAlignment":
                this.aen(function (d) { return d.horizontalAlignment = _this.aex; });
                break;
            case "YAxisTitleAlignment":
                this.aes(function (d) { return d.verticalAlignment = _this.af0; });
                break;
            case "XAxisTitle":
                this.aej(function (d) { return d.g7 = _this.acw; });
                break;
            case "YAxisTitle":
                this.aep(function (d) { return d.g7 = _this.ad1; }, false);
                break;
            case "XAxisMajorStroke":
                this.aek(function (d) { return d.jx = _this.afi; }, a);
                break;
            case "YAxisMajorStroke":
                this.aeo(function (d) { return d.jx = _this.afp; });
                break;
            case "XAxisMajorStrokeThickness":
                this.aek(function (d) { return d.es = _this.aaw; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.aeo(function (d) { return d.es = _this.abd; });
                break;
            case "XAxisMinorStroke":
                this.aej(function (d) { return d.jy = _this.afj; });
                break;
            case "YAxisMinorStroke":
                this.aeo(function (d) { return d.jy = _this.afq; });
                break;
            case "XAxisMinorStrokeThickness":
                this.aej(function (d) { return d.ev = _this.aax; });
                break;
            case "YAxisMinorStrokeThickness":
                this.aeo(function (d) { return d.ev = _this.abe; });
                break;
            case "XAxisTickLength":
                this.aej(function (d) { return d.fi = _this.aaz; });
                break;
            case "YAxisTickLength":
                this.aeo(function (d) { return d.fi = _this.abg; });
                break;
            case "XAxisTickStroke":
                this.aej(function (d) { return d.j1 = _this.afm; });
                break;
            case "YAxisTickStroke":
                this.aeo(function (d) { return d.j1 = _this.aft; });
                break;
            case "XAxisTickStrokeThickness":
                this.aej(function (d) { return d.fj = _this.aa0; });
                break;
            case "YAxisTickStrokeThickness":
                this.aeo(function (d) { return d.fj = _this.abh; });
                break;
            case "XAxisStroke":
                this.aej(function (d) { return d.j0 = _this.afl; });
                break;
            case "YAxisStroke":
                this.aeo(function (d) { return d.j0 = _this.afs; });
                break;
            case "XAxisStrokeThickness":
                this.aej(function (d) { return d.fh = _this.aay; });
                break;
            case "YAxisStrokeThickness":
                this.aeo(function (d) { return d.fh = _this.abf; });
                break;
            case "XAxisExtent":
                this.ael(function (d) { return d.extent = _this.aaq; });
                break;
            case "YAxisExtent":
                this.aeq(function (d) { return d.extent = _this.aa7; });
                break;
            case "XAxisStrip":
                this.aej(function (d) { return d.jz = _this.afk; });
                break;
            case "YAxisStrip":
                this.aeo(function (d) { return d.jz = _this.afr; });
                break;
            case "XAxisInverted":
                this.aej(function (d) { return d.ch = _this.zm; });
                break;
            case "YAxisInverted":
                this.aeo(function (d) { return d.ch = _this.zn; });
                break;
            case "YAxisLabelLocation":
                this.aer();
                break;
            case "XAxisLabelLocation":
                this.aem();
                break;
        }
    };
    XYChart.prototype.aer = function () {
        var a = this.zf(this.zj);
        if (a == 2 || a == 7) {
            this.aey = 2;
        }
        else {
            this.aey = 0;
        }
        this.aeq(function (b) { return b.location = a; });
    };
    XYChart.prototype.aem = function () {
        var a = this.ze(this.zh);
        if (a == 1 || a == 5) {
            this.afy = 0;
        }
        else {
            this.afy = 2;
        }
        this.ael(function (b) { return b.location = a; });
    };
    XYChart.prototype.zf = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.b9 == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    XYChart.prototype.ze = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(XYChart.prototype, "abq", {
        get: function () {
            return this.abo;
        },
        set: function (a) {
            var b = this.abq;
            if (a != b) {
                this.abo = a;
                this.vf("XAxisLabel", b, this.abq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abr", {
        get: function () {
            return this.abp;
        },
        set: function (a) {
            var b = this.abr;
            if (a != b) {
                this.abp = a;
                this.vf("YAxisLabel", b, this.abr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afi", {
        get: function () {
            return this.ae2;
        },
        set: function (a) {
            var b = this.afi;
            if (a != b) {
                this.ae2 = a;
                this.vf("XAxisMajorStroke", b, this.afi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afp", {
        get: function () {
            return this.ae9;
        },
        set: function (a) {
            var b = this.afp;
            if (a != b) {
                this.ae9 = a;
                this.vf("YAxisMajorStroke", b, this.afp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aaw", {
        get: function () {
            return this.zu;
        },
        set: function (a) {
            var b = this.aaw;
            if (a != b) {
                this.zu = a;
                this.vf("XAxisMajorStrokeThickness", b, this.aaw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abd", {
        get: function () {
            return this.aab;
        },
        set: function (a) {
            var b = this.abd;
            if (a != b) {
                this.aab = a;
                this.vf("YAxisMajorStrokeThickness", b, this.abd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aax", {
        get: function () {
            return this.zv;
        },
        set: function (a) {
            var b = this.aax;
            if (a != b) {
                this.zv = a;
                this.vf("XAxisMinorStrokeThickness", b, this.aax);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abe", {
        get: function () {
            return this.aac;
        },
        set: function (a) {
            var b = this.abe;
            if (a != b) {
                this.aac = a;
                this.vf("YAxisMinorStrokeThickness", b, this.abe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afk", {
        get: function () {
            return this.ae4;
        },
        set: function (a) {
            var b = this.afk;
            if (a != b) {
                this.ae4 = a;
                this.vf("XAxisStrip", b, this.afk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afr", {
        get: function () {
            return this.afb;
        },
        set: function (a) {
            var b = this.afr;
            if (a != b) {
                this.afb = a;
                this.vf("YAxisStrip", b, this.afr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afl", {
        get: function () {
            return this.ae5;
        },
        set: function (a) {
            var b = this.afl;
            if (a != b) {
                this.ae5 = a;
                this.vf("XAxisStroke", b, this.afl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afs", {
        get: function () {
            return this.afc;
        },
        set: function (a) {
            var b = this.afs;
            if (a != b) {
                this.afc = a;
                this.vf("YAxisStroke", b, this.afs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aay", {
        get: function () {
            return this.zw;
        },
        set: function (a) {
            var b = this.aay;
            if (a != b) {
                this.zw = a;
                this.vf("XAxisStrokeThickness", b, this.aay);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abf", {
        get: function () {
            return this.aad;
        },
        set: function (a) {
            var b = this.abf;
            if (a != b) {
                this.aad = a;
                this.vf("YAxisStrokeThickness", b, this.abf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aaz", {
        get: function () {
            return this.zx;
        },
        set: function (a) {
            var b = this.aaz;
            if (a != b) {
                this.zx = a;
                this.vf("XAxisTickLength", b, this.aaz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abg", {
        get: function () {
            return this.aae;
        },
        set: function (a) {
            var b = this.abg;
            if (a != b) {
                this.aae = a;
                this.vf("YAxisTickLength", b, this.abg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afm", {
        get: function () {
            return this.ae6;
        },
        set: function (a) {
            var b = this.afm;
            if (a != b) {
                this.ae6 = a;
                this.vf("XAxisTickStroke", b, this.afm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aft", {
        get: function () {
            return this.afd;
        },
        set: function (a) {
            var b = this.aft;
            if (a != b) {
                this.afd = a;
                this.vf("YAxisTickStroke", b, this.aft);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa0", {
        get: function () {
            return this.zy;
        },
        set: function (a) {
            var b = this.aa0;
            if (a != b) {
                this.zy = a;
                this.vf("XAxisTickStrokeThickness", b, this.aa0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abh", {
        get: function () {
            return this.aaf;
        },
        set: function (a) {
            var b = this.abh;
            if (a != b) {
                this.aaf = a;
                this.vf("YAxisTickStrokeThickness", b, this.abh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acw", {
        get: function () {
            return this.abu;
        },
        set: function (a) {
            var b = this.acw;
            if (a != b) {
                this.abu = a;
                this.vf("XAxisTitle", b, this.acw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ad1", {
        get: function () {
            return this.aby;
        },
        set: function (a) {
            var b = this.ad1;
            if (a != b) {
                this.aby = a;
                this.vf("YAxisTitle", b, this.ad1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afj", {
        get: function () {
            return this.ae3;
        },
        set: function (a) {
            var b = this.afj;
            if (a != b) {
                this.ae3 = a;
                this.vf("XAxisMinorStroke", b, this.afj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afq", {
        get: function () {
            return this.afa;
        },
        set: function (a) {
            var b = this.afq;
            if (a != b) {
                this.afa = a;
                this.vf("YAxisMinorStroke", b, this.afq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aar", {
        get: function () {
            return this.zp;
        },
        set: function (a) {
            var b = this.aar;
            if (a != b) {
                this.zp = a;
                this.vf("XAxisLabelAngle", b, this.aar);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa8", {
        get: function () {
            return this.z6;
        },
        set: function (a) {
            var b = this.aa8;
            if (a != b) {
                this.z6 = a;
                this.vf("YAxisLabelAngle", b, this.aa8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aaq", {
        get: function () {
            return this.zo;
        },
        set: function (a) {
            var b = this.aaq;
            if (a != b) {
                this.zo = a;
                this.vf("XAxisExtent", b, this.aaq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa7", {
        get: function () {
            return this.z5;
        },
        set: function (a) {
            var b = this.aa7;
            if (a != b) {
                this.z5 = a;
                this.vf("YAxisExtent", b, this.aa7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa1", {
        get: function () {
            return this.zz;
        },
        set: function (a) {
            var b = this.aa1;
            if (a != b) {
                this.zz = a;
                this.vf("XAxisTitleAngle", b, this.aa1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abi", {
        get: function () {
            return this.aag;
        },
        set: function (a) {
            var b = this.abi;
            if (a != b) {
                this.aag = a;
                this.vf("YAxisTitleAngle", b, this.abi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zm", {
        get: function () {
            return this.zk;
        },
        set: function (a) {
            var b = this.zm;
            if (a != b) {
                this.zk = a;
                this.vf("XAxisInverted", b, this.zm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zn", {
        get: function () {
            return this.zl;
        },
        set: function (a) {
            var b = this.zn;
            if (a != b) {
                this.zl = a;
                this.vf("YAxisInverted", b, this.zn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aex", {
        get: function () {
            return this.aeu;
        },
        set: function (a) {
            var b = this.aex;
            if (a != b) {
                this.aeu = a;
                this.vf("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aex));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "af0", {
        get: function () {
            return this.afx;
        },
        set: function (a) {
            var b = this.af0;
            if (a != b) {
                this.afx = a;
                this.vf("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.af0));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aew", {
        get: function () {
            return this.aet;
        },
        set: function (a) {
            var b = this.aew;
            if (a != b) {
                this.aet = a;
                this.vf("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aew));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_aey = function () {
        return this.aev;
    };
    XYChart.prototype.set_aey = function (a) {
        var b = this.aey;
        if (a != b) {
            this.aev = a;
            this.vf("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aey));
        }
    };
    Object.defineProperty(XYChart.prototype, "aey", {
        get: function () {
            return this.get_aey();
        },
        set: function (a) {
            this.set_aey(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afy", {
        get: function () {
            return this.afv;
        },
        set: function (a) {
            var b = this.afy;
            if (a != b) {
                this.afv = a;
                this.vf("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.afy));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afz", {
        get: function () {
            return this.afw;
        },
        set: function (a) {
            var b = this.afz;
            if (a != b) {
                this.afw = a;
                this.vf("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.afz));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "af3", {
        get: function () {
            return this.af1;
        },
        set: function (a) {
            var b = this.af3;
            if (a != b) {
                this.af1 = a;
                this.vf("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.af3));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "af4", {
        get: function () {
            return this.af2;
        },
        set: function (a) {
            var b = this.af4;
            if (a != b) {
                this.af2 = a;
                this.vf("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.af4));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_zj = function () {
        return this.zi;
    };
    XYChart.prototype.set_zj = function (a) {
        var b = this.zj;
        if (a != b) {
            this.zi = a;
            this.vf("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.zj));
        }
    };
    Object.defineProperty(XYChart.prototype, "zj", {
        get: function () {
            return this.get_zj();
        },
        set: function (a) {
            this.set_zj(a);
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_zh = function () {
        return this.zg;
    };
    XYChart.prototype.set_zh = function (a) {
        var b = this.zh;
        if (a != b) {
            this.zg = a;
            this.vf("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.zh));
        }
    };
    Object.defineProperty(XYChart.prototype, "zh", {
        get: function () {
            return this.get_zh();
        },
        set: function (a) {
            this.set_zh(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab8", {
        get: function () {
            return this.abs;
        },
        set: function (a) {
            var b = this.abs;
            if (a != b) {
                this.abs = a;
                this.vf("XAxisLabelFormat", b, this.abs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "y6", {
        get: function () {
            return this.y4;
        },
        set: function (a) {
            var b = this.y4;
            if (a != b) {
                this.y4 = a;
                this.vf("XAxisLabelFormatSpecifiers", b, this.y4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "add", {
        get: function () {
            return this.abw;
        },
        set: function (a) {
            var b = this.abw;
            if (a != b) {
                this.abw = a;
                this.vf("YAxisLabelFormat", b, this.abw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "y7", {
        get: function () {
            return this.y5;
        },
        set: function (a) {
            var b = this.y5;
            if (a != b) {
                this.y5 = a;
                this.vf("YAxisLabelFormatSpecifiers", b, this.y5);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
